#ifndef _LFOUT_H_
#define _LFOUT_H_

#include <iostream.h>
#include <float.h>

//------------------------------------------------------------------------------
// Manipulationsklasse fr LONG DOUBLE - Variablen                             -
// Da es ein automatisches CASTING (berfhren) von FLOAT und DOUBLE nach LONG -
// DOUBLE gibt, funktioniert diese Klasse auch mit FLOAT und DOUBLE-Variablen  -
//------------------------------------------------------------------------------
class lfout
{
   //---------------------------------------------------------------------------
	// Diese Variablen knnen auerhalb der Klasse nicht direkt angesprochen    -
   // werden                                                                   -
   //---------------------------------------------------------------------------
   protected:
		long double llf;  // zur Formatierung bergebener Wert                   -
		int NK;           // Anzahl der Nachkommastellen                         -
		int VK;           // Anzahl der Vorkommastellen                          -

   //---------------------------------------------------------------------------
	// Diese Methoden (Funktionen) werden von Auerhalb verwendet, um die For-  -
   // matierung aufzurufen. Da die lfout (...) Methoden sehr klein sind, werden-
   // sie hier implizit als INLINE-Funktionen (Makros) definiert.              -
   //---------------------------------------------------------------------------
	public:
      //------------------------------------------------------------------------
		// normale Formatierung, tut nix - nur der Vollstndigkeit halber        -
      // -1 hat Bedeutung von "NICHT GESETZT", da NULL ein gltiger Wert ist   -
      //------------------------------------------------------------------------
		lfout (long double lf) { set (lf, -1,  -1);   }

      //------------------------------------------------------------------------
		// nur Nachkommastellen angegeben                                        -
      //------------------------------------------------------------------------
		lfout (long double lf, int prec) { set (lf, -1,  prec); }

      //------------------------------------------------------------------------
		// Vor- und Nachkommastellen angegeben                                   -
      //------------------------------------------------------------------------
		lfout (long double lf, int vks, int prec) { set (lf, vks, prec); }

      //------------------------------------------------------------------------
		// berladen des OSTREAM-Operators << fr die Klasse LFOUT               -
      //------------------------------------------------------------------------
		friend ostream& operator << (ostream& out, lfout& f);

	//---------------------------------------------------------------------------
	// Diese Methode kann auerhalb der Klasse nicht direkt angesprochen werden -
   //---------------------------------------------------------------------------
	protected:
      //------------------------------------------------------------------------
		// Setzen der Klassenvariablen                                           -
      //------------------------------------------------------------------------
		void set (long double lf, int vks, int prec);
};
#endif
