#include <iostream.h>
#include "lfout.h"
#include <conio.h>
#include <stdlib.h>

#define STEUERSATZ_VERHEIRATET 0.18
#define STEUERSATZ_LEDIG       0.22
#define STEUERSATZ_KIRCHE      0.03
#define GEBUEHR_KIRCHE         0.70
#define KAPPUNGSGRENZE         50000.0
#define EINGABEPUFFER          500
#define KOPFSTEUER_PER_KOPF    50.0
#define EUROFAKTOR             0.2356

double fNettoeinkommen;
double fGesamtsteuer;
double fGesamtsteuerEuro;

//------------------------------------------------------------------------------
// PROTOTYPEN
//------------------------------------------------------------------------------
double fnEingabeDouble (char *psText, double fMin);
int    fnEingabeInt    (char *psText, int    nMin);
char   fnEingabeChar   (char *psText, char  *psAllowed);

double fnCalcKopfsteuer       (int nAnzahlErwachsene);
double fnCalcKinderfreibetrag (int nAnzahlKinder);
double fnCalcBruttoFuerSteuer (double fBrutto, double fKopfsteuer, double fKinderfreibetrag);
double fnCalcLohnsteuer       (double fSteuerBrutto, char cVerheiratet);
double fnCalcSteuersatz       (char cVerheiratet);
double fnCalcKirchensteuer    (double fBrutto, char cStatus);
double fnCalcKirchengebuehr   (char cStatus);
double fnCalcGesamtsteuer     (double fLohnst, double fKopfst, double fKirchenst,
                               double fKgeb);
double fnCalcNettoeinkommen   (double fJahresbrutto, double fGesamtst);
double fnEuroUmrechnung       (double fBetrag);

//------------------------------------------------------------------------------
// Hauptprogramm
//------------------------------------------------------------------------------
double fnEuroUmrechnung (double fBetrag)
{
	return fBetrag * EUROFAKTOR;
}

//------------------------------------------------------------------------------
// Hauptprogramm
//------------------------------------------------------------------------------
void main (void)
{
   double fEinkommen      = fnEingabeDouble("Jahreseinkommen .........[Na]: ", 0.0);
   int    nErwachsene     = fnEingabeInt   ("Anzahl Erwachsene im Haushalt: ", 1);
   int    nKinder         = fnEingabeInt   ("Anzahl Kinder im Haushalt ...: ", 0);
   char   cVerheiratet    = fnEingabeChar  ("Verheiratet ............[j/n]: ", "jn");
   char   cKirchenmitglied= fnEingabeChar  ("Kirchenmitglied ........[j/n]: ", "jn");

   cout << endl << endl
        << "-----------------------------------------------------------------"
        << endl << endl;

   double fKopfsteuer     = fnCalcKopfsteuer       (nErwachsene);
	double fKinderabzug    = fnCalcKinderfreibetrag (nKinder);
   double fSteuerBrutto   = fnCalcBruttoFuerSteuer (fEinkommen, fKopfsteuer, fKinderabzug);
   double fLohnsteuer     = fnCalcLohnsteuer       (fSteuerBrutto, cVerheiratet);
	double fKirchengebuehr = fnCalcKirchengebuehr   (cKirchenmitglied);
	double fKirchensteuer  = fnCalcKirchensteuer    (fSteuerBrutto,  cKirchenmitglied);
   double fGesamtsteuer   = fnCalcGesamtsteuer     (fLohnsteuer, fKopfsteuer,
                                                    fKirchensteuer, fKirchengebuehr);
	double fNettoeinkommen = fnCalcNettoeinkommen   (fEinkommen, fGesamtsteuer);

	cout << "  Anzahl Erwachsene .................: " << nErwachsene      << endl;
	cout << "  Anzahl Kinder .....................: " << nKinder          << endl;
	cout << "  Verheiratet .......................: " << cVerheiratet     << endl;
	cout << "  Kirchenmitglied....................: " << cKirchenmitglied << endl;
	cout << "  -------------------------------------------------------" << endl;
 	cout << "  Jahreseinkommen ...................: " << lfout(fEinkommen, 8,2)
                                                     << " Na" << endl;
   cout << "- Kopfsteuer pro Jahr ...............: " << lfout(fKopfsteuer, 8,2)
                                                     << " Na" << endl;
   cout << "- Kinderabzug .......................: " << lfout(fKinderabzug, 8,2)
                                                     << " Na" << endl << endl;
   cout << "= Lohnsteuerpflichtig ...............: " << lfout(fSteuerBrutto, 8,2)
                                                     << " Na" << endl;

 	cout << "  Jahreseinkommen ...................: " << lfout(fEinkommen, 8,2)
                                                     << " Na" << endl;
   cout << "- Kopfsteuer pro Jahr ...............: " << lfout(fKopfsteuer, 8,2)
                                                     << " Na" << endl;
   cout << "- Lohnsteuer ........................: " << lfout(fLohnsteuer, 8,2)
                                                     << " Na [" << fnCalcSteuersatz(cVerheiratet)
                                                     << " %]" << endl;
   cout << "- Kirchensteuer......................: " << lfout(fKirchensteuer, 8,2)
                                                     << " Na" << endl;
   cout << "- Kirchengebuehr.....................: " << lfout(fKirchengebuehr, 8,2)
                                                     << " Na" << endl;
   cout << "= Gesamtsteuer ......................: " << lfout(fGesamtsteuer, 8,2)
                                                     << " Na ["
                                                     << lfout(fnEuroUmrechnung(fGesamtsteuer), 4,2)
                                                     << " Euro]" << endl << endl;
   cout << "= Nettoeinkommen ....................: " << lfout(fNettoeinkommen, 8,2)
                                                     << " Na" << endl;

   getch(); // Borland spezifisch
}

//------------------------------------------------------------------------------
// EINGABE einer Fliesskommazahl
//------------------------------------------------------------------------------
double fnEingabeDouble (char *psText, double fMin)
{
   char sTemp [EINGABEPUFFER] = "";
   double fRC;

	do
   {
		cout << psText;
      cin.getline (sTemp, 500);
      fRC = atof (sTemp);
	}
   while (fRC < fMin);

   return fRC;
}

//------------------------------------------------------------------------------
// EINGABE einer Integer-Zahl
//------------------------------------------------------------------------------
int fnEingabeInt (char *psText, int nMin)
{
   char sTemp [EINGABEPUFFER] = "";
   int nRC;

	do
   {
		cout << psText;
      cin.getline (sTemp, 500);
      nRC = atoi (sTemp);
	}
   while (nRC < nMin);

   return nRC;
}

//------------------------------------------------------------------------------
// EINGABE eines Zeichens
//------------------------------------------------------------------------------
char fnEingabeChar (char *psText, char *psAllowed)
{
   char sTemp [EINGABEPUFFER] = "";
   char cRC;

	do
   {
		cout << psText;
      cin.getline (sTemp, 500);
      cRC = sTemp[0];
	}
   while (!strchr (psAllowed, cRC));

   return cRC;
}

//------------------------------------------------------------------------------
// Berechnung der Kopfsteuer
//------------------------------------------------------------------------------
double fnCalcKopfsteuer (int nAnzahlErwachsene)
{
	return nAnzahlErwachsene * KOPFSTEUER_PER_KOPF;
}

//------------------------------------------------------------------------------
// Berechnung des Kinderfreibetrages
//------------------------------------------------------------------------------
double fnCalcKinderfreibetrag (int nAnzahlKinder)
{
   switch (nAnzahlKinder)
   {
   	case  0: return  0.0;
      case  1: return 20.0;
      default: return 45.0 + (nAnzahlKinder-2) * 33.33;
   }
}

//------------------------------------------------------------------------------
// Berechnung des zu versteuernden Bruttos
//------------------------------------------------------------------------------
double fnCalcBruttoFuerSteuer (double fBrutto, double fKopfsteuer,
                               double fKinderfreibetrag)
{
	double fRC = fBrutto - fKopfsteuer;
   if (fRC > KAPPUNGSGRENZE)
   {
   	fRC = KAPPUNGSGRENZE;
   }
   return fRC - fKinderfreibetrag;
}

//------------------------------------------------------------------------------
// Berechnung Steuersatz
//------------------------------------------------------------------------------
double fnCalcSteuersatz (char cStatus)
{
   if (cStatus == 'j')
   {
   	return STEUERSATZ_VERHEIRATET;
   }
  	return STEUERSATZ_LEDIG;
}

//------------------------------------------------------------------------------
// Berechnung der Lohnsteuer
//------------------------------------------------------------------------------
double fnCalcLohnsteuer (double fBrutto, char cStatus)
{
 	return fBrutto * fnCalcSteuersatz (cStatus);
}

//------------------------------------------------------------------------------
// Berechnung der Kirchensteuer
//------------------------------------------------------------------------------
double fnCalcKirchensteuer (double fBrutto, char cStatus)
{
   if (cStatus == 'j')
   {
   	return fBrutto * STEUERSATZ_KIRCHE;
   }
   return 0.0;
}

//------------------------------------------------------------------------------
// Berechnung der Kirchengebhr
//------------------------------------------------------------------------------
double fnCalcKirchengebuehr (char cStatus)
{
   if (cStatus == 'j')
   {
      return GEBUEHR_KIRCHE;
   }
   return 0.0;
}

//------------------------------------------------------------------------------
// Berechnung der Gesamtsteuer
//------------------------------------------------------------------------------
double fnCalcGesamtsteuer   (double fLohnst, double fKopfst, double fKirchenst,
                             double fKgeb)
{
   return fLohnst + fKopfst + fKirchenst + fKgeb;
}

//------------------------------------------------------------------------------
// Berechnung des Nettoeinkommens
//------------------------------------------------------------------------------
double fnCalcNettoeinkommen (double fJahresEinkommen, double fGesamtst)
{
   return fJahresEinkommen - fGesamtst;
}



