#include <math.h>
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <conio.h>
#include "lfout.h"

#define EINGABEPUFFER 256

int    qsort_ElCommandante (const void *a, const void *b);
void   fnBubblesort        (double *afArray, int nAnzahl);
int    fnEingabeInteger    (char *psText, int nMin);
char   fnEingabeChar       (char *psText, char *psAllowed);
double fnEingabeDouble     (char *psText, double fMin);

// *****************************************************************
// * Beginn des Hauptprogramms                                     *
// *****************************************************************
void main (void)
{
   double *afEingabe;
   int    nAnzahl;
   double fGes = 0.0;
   double fSchnitt;
   double fMindestumsatz;
   char   cAuswahl;

	nAnzahl = fnEingabeInteger ("Bitte Anzahl der Hotels eingeben (min 2) : ", 2);
   afEingabe = new double [nAnzahl];

	//---------------------------------------------------------------
	// die nachfolgende Schleife wird mindestens einmal ausgefhrt
	//---------------------------------------------------------------
	for (int i=0; i<nAnzahl; i++)
	{
		cout << "Bitte " << setw(2) << (i+1);
		afEingabe[i] = fnEingabeDouble (". Einnahme eingeben : ", 0.0);
   }

	//---------------------------------------------------------------
	// Eingabe des Mindestumsatzes
	//---------------------------------------------------------------
   cout << endl;
	fMindestumsatz = fnEingabeDouble ("Mindestumsatz (Lagervermeidung) eingeben : ", 0.0);
   cout << endl;

	//---------------------------------------------------------------
	// Summe und Durchschnitt ermitteln
	//---------------------------------------------------------------
	for (int i=0; i<nAnzahl; i++)
	{
		fGes = fGes + afEingabe[i];
   }
   fSchnitt = fGes / nAnzahl;

	//---------------------------------------------------------------
	// Sortieren
	//---------------------------------------------------------------
   cAuswahl = fnEingabeChar ("Bubblesort oder Quicksort [b/q]: ", "bBqQ");

	switch (cAuswahl)
   {
   	case 'b':
      case 'B': fnBubblesort (afEingabe, nAnzahl);
                break;
   	default:  qsort((void *)afEingabe, nAnzahl, sizeof(afEingabe[0]), qsort_ElCommandante);
                break;
   }

	//---------------------------------------------------------------
	// Ergebnisausgabe
	//---------------------------------------------------------------
	for (int i=0; i<nAnzahl; i++)
	{
		cout << setw(2) << (i+1) << ". Einnahme: " << lfout(afEingabe[i], 8,2);
      if (afEingabe[i] < fMindestumsatz)
      {
      	cout << "   (*** Lager ***)";
      }
      cout << endl;
   }

	cout << endl << "Minimum .............: " << afEingabe[0];
	cout << endl << "Maximum (Orden) .....: " << afEingabe[nAnzahl-1];
	cout << endl << "Gesamteinnahmen .....: " << fGes;
	cout << endl << "Durchschnitt ........: " << fSchnitt;
	cout << endl << "Anzahl Hotels........: " << nAnzahl;

	delete [] afEingabe;
   getch();
}

//------------------------------------------------------------------------------
// EINGABE einer Integerzahl
//------------------------------------------------------------------------------
int fnEingabeInteger (char *psText, int nMin)
{
   char sTemp [EINGABEPUFFER] = "";
   int nRC;

	do
   {
		cout << psText;
      cin.getline (sTemp, 500);
      nRC = atoi (sTemp);
	}
   while (nRC < nMin);

   return nRC;
}

//------------------------------------------------------------------------------
// EINGABE einer Fliesskommazahl
//------------------------------------------------------------------------------
double fnEingabeDouble (char *psText, double fMin)
{
   char sTemp [EINGABEPUFFER] = "";
   double fRC;

	do
   {
		cout << psText;
      cin.getline (sTemp, 500);
      fRC = atof (sTemp);
	}
   while (fRC < fMin);

   return fRC;
}

//------------------------------------------------------------------------------
// EINGABE eines Zeichens
//------------------------------------------------------------------------------
char fnEingabeChar (char *psText, char *psAllowed)
{
   char sTemp [EINGABEPUFFER] = "";
   char cRC;

	do
   {
		cout << psText;
      cin.getline (sTemp, 500);
      cRC = sTemp[0];
	}
   while (!strchr (psAllowed, cRC));

   return cRC;
}

//------------------------------------------------------------------------------
// Einfaches Sortieren
//------------------------------------------------------------------------------
void fnBubblesort (double *afArray, int nAnzahl)
{
	double fBuffer;

	for (int i=0; i<nAnzahl-1; i++)
   {
   	for (int j=i+1; j<nAnzahl; j++)
      {
      	if (afArray[j] < afArray [i])
         {
         	fBuffer    = afArray[i];
            afArray[i] = afArray[j];
            afArray[j] = fBuffer;
         }
      }
   }
}

//------------------------------------------------------------------------------
// Bewertungsfunktion fr Quick-Sort
//------------------------------------------------------------------------------
int qsort_ElCommandante (const void *a, const void *b)
{
	double *pa = (double *)a;
	double *pb = (double *)b;
	if (*pa < *pb) return -1;
	if (*pa > *pb) return +1;
   return 0;
}
