#include <math.h>
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <conio.h>
#include "lfout.h"

#define EINGABEPUFFER 256
#define NAMENLAENGE   300
#define ANZMONATE       3

struct Hotel {char sName[NAMENLAENGE]; double fEinnahmen[ANZMONATE];
              double fSumme; double fSchnitt;};

double fnEingabeDouble      (char *psText, double fMin);
int    fnEingabeInteger     (char *psText, int nMin);
char  *fnEingabeText        (char *psTextAusgabe, char *psTextEingabe, int nMax);
void   fnLiesHotelEinnahmen (Hotel &rHotel, int nMonate);
void   fnHotelAusgabe       (const Hotel &rHotel, int nMonate, double fMindestumsatz);
int    qsort_Hotel          (const void *a, const void *b);
void   fnHotelMinMax        (const Hotel &rHotel, int nMonate, double &fMin, double &fMax);

inline void fnNewPage (void) {clrscr();}

// *****************************************************************
// * Beginn des Hauptprogramms                                     *
// *****************************************************************
void main (void)
{
   Hotel *aHotels;
   int    nAnzahl;
   double fMindestumsatz;
   double fMinimum;
   double fMaximum;
   double fGesamtSumme;
   double fGesamtSchnitt;

	nAnzahl = fnEingabeInteger ("Anzahl der Hotels eingeben (min 2) : ", 2);
   aHotels = new Hotel [nAnzahl];
   fnNewPage();

	//---------------------------------------------------------------
	// zuerst die Hotelnamen eingeben
	//---------------------------------------------------------------
	for (int i=0; i<nAnzahl; i++)
	{
		cout << "Bitte " << setw(2) << (i+1);
		fnEingabeText (". Hotelnamen eingeben : ", aHotels[i].sName, NAMENLAENGE);
   }
   fnNewPage();

	//---------------------------------------------------------------
	// Eingabe des Mindestumsatzes
	//---------------------------------------------------------------
	fMindestumsatz = fnEingabeDouble ("Mindestumsatz (Lagervermeidung) : ", 0.0);
   cout << endl;
   fnNewPage();

	//---------------------------------------------------------------
	// Nacheinander die Hoteleinnahmen eingeben
	//---------------------------------------------------------------
	for (int i=0; i<nAnzahl; i++)
	{
	   cout << "Einnahmen fr das Hotel " << aHotels[i].sName << " eingeben:"
           << endl;
      fnLiesHotelEinnahmen (aHotels[i], ANZMONATE);
      cout << endl;
   }
   fnNewPage();

	//---------------------------------------------------------------
	// Sortieren
	//---------------------------------------------------------------
   qsort((void *)aHotels, nAnzahl, sizeof(Hotel), qsort_Hotel);

	//---------------------------------------------------------------
	// Ergebnisausgabe
	//---------------------------------------------------------------
	for (int i=0; i<nAnzahl; i++)
	{
		fnHotelAusgabe (aHotels[i], ANZMONATE, fMindestumsatz);
   }

   fMaximum = fMinimum = aHotels[0].fEinnahmen[0];
	fGesamtSumme = 0.0;
	for (int i=0; i<nAnzahl; i++)
	{
	   fnHotelMinMax (aHotels[i], ANZMONATE, fMinimum, fMaximum);
      fGesamtSumme = fGesamtSumme + aHotels[i].fSumme;
   }

   fGesamtSchnitt = fGesamtSumme / nAnzahl;

	cout << endl << "Minimum .............: " << lfout (fMinimum, 8, 2);
	cout << endl << "Maximum (Orden) .....: " << lfout (fMaximum, 8, 2);
	cout << endl << "Gesamteinnahmen .....: " << lfout (fGesamtSumme, 8, 2);
	cout << endl << "Durchschnitt ........: " << lfout (fGesamtSchnitt, 8, 2);
	cout << endl << "Anzahl Hotels........: " << nAnzahl;

	delete [] aHotels;
   getch();
}

//------------------------------------------------------------------------------
// EINGABE einer Fliesskommazahl
//------------------------------------------------------------------------------
double fnEingabeDouble (char *psText, double fMin)
{
   char sTemp [EINGABEPUFFER] = "";
   double fRC;

	do
   {
		cout << psText;
      cin.getline (sTemp, 500);
      fRC = atof (sTemp);
	}
   while (fRC < fMin);

   return fRC;
}

//------------------------------------------------------------------------------
// EINGABE einer Integerzahl
//------------------------------------------------------------------------------
int fnEingabeInteger (char *psText, int nMin)
{
   char sTemp [EINGABEPUFFER] = "";
   int nRC;

	do
   {
		cout << psText;
      cin.getline (sTemp, 500);
      nRC = atoi (sTemp);
	}
   while (nRC < nMin);

   return nRC;
}

//------------------------------------------------------------------------------
// EINGABE eines Textes
//------------------------------------------------------------------------------
char *fnEingabeText (char *psTextAusgabe, char *psTextEingabe, int nMax)
{
	cout << psTextAusgabe;
   cin.getline (psTextEingabe, nMax);
   return psTextEingabe;
}

//------------------------------------------------------------------------------
// Bewertungsfunktion fr Quick-Sort
//------------------------------------------------------------------------------
int qsort_Hotel (const void *a, const void *b)
{
	Hotel *pa = (Hotel *)a;
	Hotel *pb = (Hotel *)b;
   return strcmp (pa->sName, pb->sName);
}

//------------------------------------------------------------------------------
// Eingabe der Einnnahmen
//------------------------------------------------------------------------------
void fnLiesHotelEinnahmen (Hotel &rHotel, int nMonate)
{
	for (int i=0; i<nMonate; i++)
   {
   	cout << (i+1);
   	rHotel.fEinnahmen[i] = fnEingabeDouble (". Monat: ", 0.0);
   }

   //---------------------------------------------------------------------------
	// Summe bilden
   //---------------------------------------------------------------------------
	rHotel.fSumme = 0.0;
	for (int i=0; i<nMonate; i++)
   {
   	rHotel.fSumme = rHotel.fSumme + rHotel.fEinnahmen[i];
   }

   //---------------------------------------------------------------------------
	// Durchschnitt bilden
   //---------------------------------------------------------------------------
  	rHotel.fSchnitt = rHotel.fSumme / nMonate;
}

void fnHotelAusgabe (const Hotel &rHotel, int nMonate, double fMindestumsatz)
{
	long old = cout.setf(ios::left, ios::adjustfield);
	cout << "Hotel: " << setw(20) << rHotel.sName
        << "  [Summe: " << lfout(rHotel.fSumme, 2, 2)
        << " | Schnitt: " << lfout(rHotel.fSchnitt, 8,2) << "]" << endl;
   cout << "       Einnahmen: ";
	cout.setf(old, ios::adjustfield);;
   for (int j=0; j<nMonate; j++)
   {
      cout << " " << lfout(rHotel.fEinnahmen[j], 8,2);
      if (rHotel.fEinnahmen[j] < fMindestumsatz)
      {
         cout << "* ";
      }
      else
      {
         cout << "  ";
      }
   }
   cout << endl << endl;
}

void fnHotelMinMax (const Hotel &rHotel, int nMonate, double &fMin, double &fMax)
{
   for (int j=0; j<nMonate; j++)
   {
   	if (rHotel.fEinnahmen[j] < fMin) fMin = rHotel.fEinnahmen[j];
   	if (rHotel.fEinnahmen[j] > fMax) fMax = rHotel.fEinnahmen[j];
   }
}
